unit EditeCarD;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, Menus, Grids, Buttons, ExtCtrls, CheckLst, ComCtrls;

type
  TFormModifcaracD = class(TForm)
    MainMenu1: TMainMenu;
    Ajouteruncaractre1: TMenuItem;
    Retireruncaractre1: TMenuItem;
    PanelChoix: TPanel;
    ComboChoix: TComboBox;
    PanelEtatMult: TPanel;
    PanelOK: TPanel;
    BitBtn2: TBitBtn;
    OK: TBitBtn;
    TabCarNouv: TStringGrid;
    PanelAnalogie: TPanel;
    Panel3: TPanel;
    Label2: TLabel;
    Label3: TLabel;
    PanelReversion: TPanel;
    Panel1: TPanel;
    Label5: TLabel;
    NvEtat: TEdit;
    Label6: TLabel;
    ListeTaxonsRev: TCheckListBox;
    Panel5: TPanel;
    Panel4: TPanel;
    LinstrL3: TLabel;
    PanelTitre: TPanel;
    PanelExplic: TPanel;
    instructions: TRichEdit;
    Panel2: TPanel;
    OK1: TButton;
    LTitre: TLabel;
    ListTaxonsCar1Der: TCheckListBox;
    Label4: TLabel;
    LinstrL2: TLabel;
    NomCarOrg: TEdit;
    Label7: TLabel;
    Label8: TLabel;
    NomCarAnalg: TEdit;
    procedure Ajouteruncaractre1Click(Sender: TObject);
    procedure Retireruncaractre1Click(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure OK1Click(Sender: TObject);
    procedure NomCarOrgChange(Sender: TObject);
    procedure OKClick(Sender: TObject);
  private
    { Dclarations prives }
    function VerifieCaracteres:Boolean;
  public
    { Dclarations publiques }
    EtatsMultiples:boolean;
    Reversion:Boolean;
    DeuxiemEtape:Boolean;
    NomDerivAnalg:string;
    CaracteresD:TList;
  end;

var
  FormModifcaracD: TFormModifcaracD;

implementation
uses donnees,GestionTextes;
{$R *.dfm}

procedure TFormModifcaracD.Ajouteruncaractre1Click(Sender: TObject);
Var
  n:integer;
begin
  n:=TabCarNouv.ColCount;
  TabCarNouv.ColCount:=n+1;
//  TabCarNouv.Cells[n,0]:='Nouveau caractre '+IntToStr(n);
  TabCarNouv.Cells[n,0]:=M_Nouveaucaractre_2+IntToStr(n);
  TabCarNouv.ColWidths[n]:=TabCarNouv.Canvas.TextWidth(TabCarNouv.Cells[n,0])+4;
end;

procedure TFormModifcaracD.Retireruncaractre1Click(Sender: TObject);
begin
  if TabCarNouv.ColCount>3 then TabCarNouv.ColCount:=TabCarNouv.ColCount-1;
end;

procedure TFormModifcaracD.FormShow(Sender: TObject);
Var
  NomFichier:string;
  i,j,larg:integer;
begin
  DeuxiemEtape:=False;
  PanelTitre.Visible:=false;
  PanelReversion.Visible:=false;
  PanelEtatMult.Visible:=false;
  PanelAnalogie.Visible:=false;
  PanelExplic.Visible:=True;
  Menu:=Nil;
  if EtatsMultiples then
    begin
      PanelChoix.Visible:=False;
      NomFichier:=CheminProg+'EtatsMult.rtf';
      TabCarNouv.Cells[1,1]:='';
      larg:=TabCarNouv.Canvas.TextWidth(TabCarNouv.Cells[0,0])+4;
      for j:=1 to TabCarNouv.RowCount-1 do
        if (TabCarNouv.Canvas.TextWidth(TabCarNouv.Cells[0,j])+4)>larg then
          larg:=(TabCarNouv.Canvas.TextWidth(TabCarNouv.Cells[0,j])+4);
      TabCarNouv.ColWidths[0]:=larg;
      for i:=1 to TabCarNouv.ColCount-1 do
        begin
          TabCarNouv.ColWidths[i]:=TabCarNouv.Canvas.TextWidth(TabCarNouv.Cells[i,0])+4;
          for j:=1 to TabCarNouv.RowCount-1 do
            TabCarNouv.Cells[i,j]:='';
        end;
    end
  else
    begin
      PanelChoix.Visible:=True;
      NomFichier:=CheminProg+'Analogie.rtf';
    end;
  instructions.Lines.LoadFromFile(NomFichier);
end;

procedure TFormModifcaracD.FormCreate(Sender: TObject);
begin
  Caption:=C_FormModifcaracD; // Dcomposer le caractre 
  Label5.Caption:=C_FormModifcaracDLabel5; // Nom de l'233tat de rversion :
  Label6.Caption:=C_FormModifcaracDLabel61+Chr(13)+Chr(10)+C_FormModifcaracDLabel6; // ayant l'233tat de rversion
  NvEtat.Text:=C_FormModifcaracDNvEtat; // Disparu
  OK1.Caption:=C_FormPrincOKgroupe; // OK
  Label2.Caption:=C_FormModifcaracDLabel2; // Nouveaux Caractres
  Label7.Caption:=C_FormModifcaracDLabel7; // Caractre 1
  Label8.Caption:=C_FormModifcaracDLabel8; // Caractre 2
  LinstrL3.Caption:=C_FormModifcaracDLinstrL3; // est  l'233tat driv : 
  Label4.Caption:=C_FormModifcaracDLabel4; // Indiquez les noms des nouveaux caractres
  LinstrL2.Caption:=C_FormModifcaracDLinstrL2; // et cocher les taxons o
  Label3.Caption:=C_FormModifcaracDLabel3; // Choisir le cas  traiter :
  ComboChoix.Text:=C_FormModifcaracDComboChoix; // Analogie suppose : scinder le caractre
  Ajouteruncaractre1.Caption:=C_FormModifcaracDAjouteruncaractre1; // Ajouter un caractre
  Retireruncaractre1.Caption:=C_FormModifcaracDRetireruncaractre1; // Retirer un caractre
  EtatsMultiples:=True;;
  Reversion:=False;
  DeuxiemEtape:=False;
//  TabCarNouv.Cells[0,0]:='Caractre initial';
  TabCarNouv.Cells[0,0]:=M_Caractreinitial;
//  TabCarNouv.Cells[1,0]:='Nouveau caractre 1';
  TabCarNouv.Cells[1,0]:=M_Nouveaucaractre;
//  TabCarNouv.Cells[2,0]:='Nouveau caractre 2';
  TabCarNouv.Cells[2,0]:=M_Nouveaucaractre_1;
end;

procedure TFormModifcaracD.OK1Click(Sender: TObject);
begin
  DeuxiemEtape:=True;
  PanelTitre.Visible:=True;
  PanelExplic.Visible:=False;
  PanelChoix.Visible:=False;

  if EtatsMultiples then
    begin
      Menu:=MainMenu1;
      PanelEtatMult.Visible:=True;
//      LTitre.Caption:='Etats multiples non ordonns : scinder le caractre'+#13+#10+
      LTitre.Caption:=M_Etatsmultiplesnono+#13+#10+
//                      'crire les noms des nouveaux caractres'+#13+#10+
                      M_crirelesnomsdesnou+#13+#10+
//                      'et donner la correspondance avec les anciens tats';
                      M_etdonnerlacorrespo;
      PanelTitre.Height:=53;
    end
  else
    begin
      Reversion:=(ComboChoix.ItemIndex=1);
      if Reversion then
        begin
//          LTitre.Caption:='Cas de rversion : nommer l''tat de rversion'+#13+#10+
          LTitre.Caption:=M_Casderversionnomme+#13+#10+
//                      'et cocher les taxons possdant cet tat'+#13+#10+
                      M_etcocherlestaxonsp+#13+#10+
//                      'du caractre';
                      L_Caractere;
          PanelReversion.Visible:=True;
          PanelTitre.Height:=53;
        end
      else
        begin
//          LTitre.Caption:='Simple analogie : scinder le caractre';
          LTitre.Caption:=M_Simpleanalogiescin;
          PanelTitre.Height:=26;
          PanelAnalogie.Visible:=True;
//          LinstrL2.Caption:='et cocher les taxons o '+NomCarOrg.Text;
          LinstrL2.Caption:=M_etcocherlestaxonso+NomCarOrg.Text;
//          LinstrL3.Caption:='est  l''tat driv : '+NomDerivAnalg;
          LinstrL3.Caption:=M_estltatdriv+NomDerivAnalg;
        end;
    end;
  OK.Visible:=True;
end;

procedure TFormModifcaracD.NomCarOrgChange(Sender: TObject);
begin
//  LinstrL2.Caption:='et cocher les taxons o '+NomCarOrg.Text;
  LinstrL2.Caption:=M_etcocherlestaxonso+NomCarOrg.Text;
end;

procedure TFormModifcaracD.OKClick(Sender: TObject);
begin
  if VerifieCaracteres then
    ModalResult:=mrOK;
    
end;
function TFormModifcaracD.VerifieCaracteres:Boolean;
Var
  i:integer;
begin
  if EtatsMultiples then
    begin
      Result:=True;
      For i:=1 to TabCarNouv.ColCount-1 do
        begin
          TabCarNouv.Cells[i,1]:=Trim(TabCarNouv.Cells[i,1]);
          if (TabCarNouv.Cells[i,1]='')or (LaSousCollection.LeCarD(TabCarNouv.Cells[i,1])<>Nil) then
            begin
              if (TabCarNouv.Cells[i,1]='') then
//                MessageDlg('il manque le nom d''un nouveau caractre',mtError,[mbOK],0)
                MessageDlg(M_ilmanquelenomdunno,mtError,[mbOK],0)
              else
//                MessageDlg('Un nom choisi pour un nouveau caractre est dj utilis',mtError,[mbOK],0);
                MessageDlg(M_Unnomchoisipourunn,mtError,[mbOK],0);
              TabCarNouv.Cells[i,1]:='';
              Result:=False;
            end;
        end;
    end
  else if Reversion then Result:=True
  else
    begin
      Result:=True;
      NomCarOrg.Text:=Trim(NomCarOrg.Text);
      NomCarAnalg.Text:=Trim(NomCarAnalg.Text);
      if (NomCarOrg.Text='')or(LaSousCollection.LeCarD(NomCarOrg.Text)<>Nil) then
        begin
          if (NomCarOrg.Text='') then
//                MessageDlg('il manque le nom d''un nouveau caractre',mtError,[mbOK],0)
                MessageDlg(M_ilmanquelenomdunno,mtError,[mbOK],0)
              else
//                MessageDlg('Un nom choisi pour un nouveau caractre est dj utilis',mtError,[mbOK],0);
                MessageDlg(M_Unnomchoisipourunn,mtError,[mbOK],0);
          NomCarOrg.Text:='';
          Result:=False;
        end;
      if (NomCarAnalg.Text='')or(LaSousCollection.LeCarD(NomCarAnalg.Text)<>Nil) then
        begin
          if (NomCarAnalg.Text='') then
//                MessageDlg('il manque le nom d''un nouveau caractre',mtError,[mbOK],0)
                MessageDlg(M_ilmanquelenomdunno,mtError,[mbOK],0)
              else
//                MessageDlg('Un nom choisi pour un nouveau caractre est dj utilis',mtError,[mbOK],0);
                MessageDlg(M_Unnomchoisipourunn,mtError,[mbOK],0);
          NomCarAnalg.Text:='';
          Result:=False;
        end;
    end;
end;
end.
